#vider la mmoire
rm(list=ls())

#charger la librairie rmr2
library(rmr2)

#fonctionner sans l'environnement hadoop
rmr.options(backend="local")

#data(mtcars)
data(mtcars)
print(mtcars)

#map
map_lm <- function(., D){
  #gnration de valeurs alatoires
  alea <- runif(nrow(D))
  #cl - dcoupage en 2 parts  peu prs gales
  #on peut facilement multiplier les sous-groupes
  cle <- ifelse(alea < 0.5, 1, 2)
  #renvoyer la cl et les donnes
  return(keyval(cle,D))
}

#reduce
reduce_lm <- function(k,D){
  #nombre de lignes
  n <- nrow(D)
  #rcupration de la cible
  y <- D$mpg
  #prdictives
  X <- as.matrix(D[,-1])
  #rajouter la constante en premire colonne
  X <- cbind(rep(1,n),X)
  #calcul de X'X
  XtX <- t(X) %*% X
  #calcul de X'y
  Xty <- t(X) %*% y
  #former une structure de liste
  res <- list(XtX = XtX, Xty = Xty)
  #renvoyer le tout
  return(keyval(k,res))
}

#format rmr2
don.dfs <- to.dfs(mtcars)

#mapreduce
calcul <- mapreduce(input=don.dfs,map=map_lm,reduce=reduce_lm)

#rcupration
resultat <- from.dfs(calcul)
print(resultat)

#consolidation
#X'X
MXtX <- matrix(0,nrow=ncol(mtcars),ncol=ncol(mtcars))
for (i in seq(1,length(resultat$val)-1,2)){
  MXtX <- MXtX + resultat$val[[i]]
}
print(MXtX)
  
#X'y
MXty <- matrix(0,nrow=ncol(mtcars),ncol=1)
for (i in seq(2,length(resultat$val),2)){
  MXty <- MXty + resultat$val[[i]]
}
print(MXty)

#coefficients de la rgression
a.chapeau <- solve(MXtX,MXty))
print(a.chapeau)

#vrification
lm(mpg ~ ., data = mtcars)
