#vider la mmoire
rm(list=ls())

#charger la librairie rmr2
library(rmr2)

#fonctionner sans l'environnement hadoop
rmr.options(backend="local")

#vecteur de valeurs entires
x <- c(2,6,67,85,7,9,4,21,78,45)

#map selon la parit de la valeur
map_valeurs <- function(., v){
  #affichage de contrle
  print("map") ; print(v)
  #calcul de la cl
  cle <- ifelse (v %% 2 == 0, 1, 2)
  #retour des vecteurs cl et valeurs
  return(keyval(cle,v))
}

#reduce sur chaque sous-vecteur
reduce_valeurs <- function(k, v){
  #affichage de contrle
  print("reduce") ; print(k) ; print(v)
  #longueur du vecteur  traiter
  nb <- length(v)
  #renvoyer la cl et le rsultat associ
  return(keyval(k, nb))
}

#transformation en type compatible rmr2
x.dfs <- to.dfs(x)

#fonction mapreduce de rmr2
calcul <- mapreduce(input = x.dfs, map = map_valeurs, reduce = reduce_valeurs)

#transformation en un type R usuel
resultat <- from.dfs(calcul)

#affichage
print(resultat)

#classe de resultat
print(class(resultat))

#affichage des cls
print(keys(resultat))

#affichage des valeurs calcules
print(values(resultat))

