#vider la mmoire
rm(list=ls())

#charger la librairie rmr2
library(rmr2)

#fonctionner sans l'environnement hadoop
rmr.options(backend="local")

#vecteur indicateur de groupe
y <- factor(c(1,1,2,1,2,3,1,2,3,2,1,1,2,3,3))

#vecteur de valeurs
x <- c(0.2,0.65,0.8,0.7,0.85,0.78,1.6,0.7,1.2,1.1,0.4,0.7,0.6,1.7,0.15)

#construire un data frame
don <- data.frame(cbind(y,x))

#map - dispatcher selon y
map_ssq <- function(., v){
  #la colonne y est la cl
  cle <- v$y
  #renvoyer la cl et le data frame entier
  return(keyval(cle,v))
}

#reduce - calcul
reduce_ssq <- function(k,v){
  #impression de contrle
  print("reduce") ; print(v)
  #compter le nombre de ligne du data frame
  n <- nrow(v)
  #calcul sur le champ (colonne) x du data.frame
  ssq <- (n-1) * var(v$x)
  #renvoyer la cl et le rsultat
  return(keyval(k,ssq))
}

#format rmr2
don.dfs <- to.dfs(don)

#mapreduce
calcul <- mapreduce(input=don.dfs,map=map_ssq,reduce=reduce_ssq)

#rcupration
resultat <- from.dfs(calcul)
print(resultat)

#SSR
ssr <- sum(resultat$val)
print(ssr)

#contrle
print(aov(x ~ y))

